-- Encoding.
vim.scriptencoding = 'utf-8'
vim.o.encoding = 'utf-8'
vim.o.fileencoding = 'utf-8'

-- Backups.
vim.o.backup = false
vim.o.swapfile = false

-- Lines.
vim.o.number = true
vim.o.relativenumber = true
vim.o.colorcolumn = '80'
vim.o.signcolumn = 'yes'
vim.o.cursorline = true
vim.o.guicursor = ''

-- Tabs.
vim.o.tabstop = 2
vim.o.shiftwidth = 2

-- Etc.
vim.o.clipboard = 'unnamedplus'

-- View.
vim.g.mapleader = ' '
-- vim.g.netrw_liststyle = 3
vim.o.termguicolors = true

vim.o.list = true
vim.opt.listchars:append 'space:·'
vim.opt.listchars:append 'tab:┊ '
-- vim.opt.listchars:append 'eol:↴'

-- Mappings tabs.
vim.keymap.set('n', '<C-h>', ':-tabmove<CR>')
vim.keymap.set('n', '<C-l>', ':+tabmove<CR>')

-- Mappings buffers.
vim.keymap.set('n', '<leader>k', ':bn<CR>')
vim.keymap.set('n', '<leader>j', ':bp<CR>')

-- Move cursour vertical.
vim.keymap.set('n', '<C-d>', '<C-d>zz')
vim.keymap.set('n', '<C-u>', '<C-u>zz')

-- Diagnostic keymaps.
vim.keymap.set('n', '[d', vim.diagnostic.goto_prev)
vim.keymap.set('n', ']d', vim.diagnostic.goto_next)
vim.keymap.set('n', '<leader>e', vim.diagnostic.open_float)
vim.keymap.set('n', '<leader>q', vim.diagnostic.setloclist)
